<template>
    <q-page class="bg-base">
        <DocumentWrapper ref="doc">
            <template>

                <div v-if="floors.length === 0">
                    <AnimationComponent text="There are currently no floors. Create one?"
                                        :animation="$animations.emptyBox"
                                        :max-height="0.9"/>
                </div>
                <ListPage v-else>

                    <q-list separator bordered>
                        <FloorItem v-for="f in floors" :key="f.id" :floor="f" :to="`floor/${f.id}`"/>
                    </q-list>

                </ListPage>
                <q-btn fab color="accent" icon="add" class="absolute-bottom-right q-ma-lg" to="/floor/create">
                    <q-tooltip anchor="center left" self="center right">
                        Create a new floor
                    </q-tooltip>
                </q-btn>

            </template>
        </DocumentWrapper>
    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import ErrorComponent from "components/Core/ErrorComponent.vue";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {FloorPrincipalResponse} from "src/classLibrary/APIModels/core/floorPrincipalResponse";
import AnimationComponent from "components/Core/AnimationComponent.vue";
import FloorItem from "components/Entities/List/FloorItem.vue";
import Container from "components/Core/Container.vue";
import ListPage from "components/Core/ListPage.vue";

@Component({
    components: {ListPage, Container, FloorItem, AnimationComponent, DocumentWrapper, ErrorComponent}
})
export default class Floors extends Vue {



    floors: FloorPrincipalResponse[] = [];

    async loadFloors() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<FloorPrincipalResponse[]>(`Floor?projectId=${this.PersistentStore.StoreValue.project}`, null, t);

        r.match({
            err: (e) => (p.$refs.doc as any).SubmitError(e),
            ok: (o) => {
                p.floors = o;
            }
        })

    }

    async mounted() {
        await this.loadFloors();
    }

}
</script>
